
/****************************************************************************

  Demos Tool


	Windows interface.

	Cyril Gantin (cgg@planetquake.com)

 ****************************************************************************/


#include <windows.h>

#define CONTROL_OUTPUT			1001
#define CONTROL_PLAYERNAME		1002
#define CONTROL_NDEMOSPERMAP	1003
#define CONTROL_EXECUTE			1004
#define CONTROL_QUIT			1005

HWND outputHwnd;
HWND playerHwnd;
HWND ndemosHwnd;
char outputBuf[1024*64];

RECT clientRect;

//from dt_main.cpp
extern char gPlayerName[];
extern int gNumDemosPerMap;
void DT_init();
void DT_run();
bool DT_CheckDefrag();
void DT_UpdateConfig();
char *va(char *fmt, ...);


void trap_print(char *s) {
	strcat(outputBuf,s);
	SetWindowText(outputHwnd,outputBuf);

	//no buffer overflow is handled since size of buffer is assumed to be fairly enough
}

void trap_error(char *s) {
	MessageBox(0,s,"Failure",MB_OK | MB_ICONWARNING);
}



LRESULT CALLBACK WndProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam) {
	char s[16];
	switch(message) {
	case WM_CREATE:

		//init DT engine
		DT_init();

		outputBuf[0] = 0;
		GetClientRect(hwnd,&clientRect);

		//Create controls
		CreateWindow("STATIC","",WS_CHILD | WS_VISIBLE | SS_ETCHEDFRAME,
					clientRect.left+5,clientRect.top+5,clientRect.right-10,70,
					hwnd,(HMENU)0,((LPCREATESTRUCT)lparam)->hInstance, NULL);

		outputHwnd = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT","",WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_READONLY | ES_MULTILINE,
					clientRect.left+1,clientRect.top+80,clientRect.right-1,clientRect.bottom-81,
					hwnd,(HMENU)CONTROL_OUTPUT,((LPCREATESTRUCT)lparam)->hInstance, NULL);

		CreateWindow("STATIC","Defrag Player Name (df_name):",WS_CHILD | WS_VISIBLE,
					clientRect.left+15,clientRect.top+18,250,23,
					hwnd,(HMENU)0,((LPCREATESTRUCT)lparam)->hInstance, NULL);
		playerHwnd = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",gPlayerName,WS_CHILD | WS_VISIBLE,
					clientRect.left+250,clientRect.top+15,100,23,
					hwnd,(HMENU)CONTROL_PLAYERNAME,((LPCREATESTRUCT)lparam)->hInstance, NULL);

		CreateWindow("STATIC","Num demos per map to keep:",WS_CHILD | WS_VISIBLE,
					clientRect.left+15,clientRect.top+48,250,23,
					hwnd,(HMENU)0,((LPCREATESTRUCT)lparam)->hInstance, NULL);
		ndemosHwnd = CreateWindowEx(WS_EX_CLIENTEDGE,"EDIT",itoa(gNumDemosPerMap,s,10),WS_CHILD | WS_VISIBLE | ES_NUMBER,
					clientRect.left+250,clientRect.top+45,35,23,
					hwnd,(HMENU)CONTROL_NDEMOSPERMAP,((LPCREATESTRUCT)lparam)->hInstance, NULL);

		CreateWindowEx(WS_EX_CLIENTEDGE,"BUTTON","Execute",WS_CHILD | WS_VISIBLE,
					clientRect.right-120,clientRect.top+15,100,23,
					hwnd,(HMENU)CONTROL_EXECUTE,((LPCREATESTRUCT)lparam)->hInstance, NULL);
		CreateWindowEx(WS_EX_CLIENTEDGE,"BUTTON","Quit",WS_CHILD | WS_VISIBLE,
					clientRect.right-120,clientRect.top+45,100,23,
					hwnd,(HMENU)CONTROL_QUIT,((LPCREATESTRUCT)lparam)->hInstance, NULL);
		break;


	case WM_COMMAND:
		if (HIWORD(wparam) == BN_CLICKED && LOWORD(wparam) == CONTROL_EXECUTE) {
			char arg[128];
			int ndemos;
			bool needUpdate = false;

			GetWindowText(ndemosHwnd,arg,sizeof(arg));
			ndemos = atoi(arg);
			if (ndemos != gNumDemosPerMap) {
				if (ndemos < 1) {
					SetWindowText(ndemosHwnd,"1");
					MessageBox(hwnd,"Value must be set from 1 to 16","Warning",MB_OK | MB_ICONWARNING);
					break;
				} else if (ndemos > 16) {
					MessageBox(hwnd,"Value must be set from 1 to 16","Warning",MB_OK | MB_ICONWARNING);
					SetWindowText(ndemosHwnd,"16");
					break;
				}
				gNumDemosPerMap = ndemos;
				needUpdate = true;
			}
			GetWindowText(playerHwnd,arg,sizeof(arg));
			if (strcmp(arg,gPlayerName)) {
				needUpdate = true;
				strncpy(gPlayerName,arg,sizeof(arg));
			}

			if (needUpdate)
				DT_UpdateConfig();

			//reset buffer
			outputBuf[0] = 0;
			DT_run();
		}
		if (HIWORD(wparam) == BN_CLICKED && LOWORD(wparam) == CONTROL_QUIT) {
			PostQuitMessage(0);
			return 0;
		}
		break;


	case WM_CLOSE:
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd,message,wparam,lparam);
}

int WINAPI WinMain	(HINSTANCE hInstance,HINSTANCE hPrevInstance,PSTR szCmdLine,int CmdShow) {
	WNDCLASSEX wndclass;
	HWND hwnd;
	MSG msg;

	//Verify we are running from the right Defrag version
	if (!DT_CheckDefrag())
		return EXIT_FAILURE;

	//Create window class
	wndclass.cbSize		= sizeof(wndclass);
	wndclass.style		= CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc	= WndProc;
	wndclass.cbClsExtra	= 0;
	wndclass.cbWndExtra	= 0;
	wndclass.hInstance	= hInstance;
	wndclass.hIcon		= LoadIcon(NULL,IDI_WINLOGO);
	wndclass.hCursor	= LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground	= (HBRUSH) COLOR_BACKGROUND;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= "demostoolWnd";
	wndclass.hIconSm	= LoadIcon(NULL,IDI_WINLOGO);

	RegisterClassEx(&wndclass);

	//Create window
	hwnd = CreateWindow	("demostoolWnd","Demos Tool for Defrag",WS_SYSMENU,
				CW_USEDEFAULT,CW_USEDEFAULT,550,350,
				NULL,NULL,hInstance,NULL);

	ShowWindow(hwnd,CmdShow);
	UpdateWindow(hwnd);

	//Enter message loop
	while(GetMessage(&msg,NULL,0,0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	//Exit
	UnregisterClass("demostoolWnd",hInstance);

	return msg.wParam;
}
